"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var xhr = require("xhr");
var TemplateProvider = (function () {
    function TemplateProvider() {
    }
    TemplateProvider.prototype.get = function (template, noCache) {
        var version = '';
        if (noCache) {
            version = '?v=' + new Date().getTime().toString();
        }
        var dfd = new Promise(function (resolve, reject) {
            xhr.get(template + version, {
                timeout: 4000
            }, function (error, response, body) {
                if (error) {
                    reject(error);
                }
                else {
                    resolve(body);
                }
            });
        });
        return dfd;
    };
    return TemplateProvider;
}());
exports.TemplateProvider = TemplateProvider;
//# sourceMappingURL=TemplateProvider.js.map