﻿/// <binding AfterBuild='Run - Development' />
module.exports = {
  context: __dirname + '/lib',
  resolve: {
    extensions: ['.js', '.ts'],
    alias: {
      "event-handler-manager": "event-handler-manager/dist/event-handler-manager"
    }
  },
  entry: {
    app: __dirname + '/index.ts'
  },
  output: {
    path: __dirname + '/dist',
    filename: 'widget-router.js',
    library: 'WidgetRouter',
    libraryTarget: 'umd',
    umdNamedDefine: true
  },
  module: {
    rules: [
      {
        test: /\.ts$/,
        exclude: /node_modules/,
        loader: 'awesome-typescript-loader'
      }
    ]
  }
};